package api_types

import (
	"github.com/juju/errors"

	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_types/gin_gonic"
	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_types/go_swagger"
	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_types/mojolicious"
	"git.home.m-and-m.ovh/mderasse/gouick/helpers/models"
)

func GetAPIType(in models.APITypeName) (APITypeInterface, error) {
	if in == "" {
		return nil, errors.BadRequestf("missing parameter")
	}

	if !in.IsValid() {
		return nil, errors.NotValidf("invalid parameter")
	}

	switch in {
	case models.APITypeName_GIN_GONIC:
		return gin_gonic.APIType{}, nil
	case models.APITypeName_GO_SWAGGER:
		return go_swagger.APIType{}, nil
	case models.APITypeName_MOJOLICIOUS:
		return mojolicious.APIType{}, nil
	}

	return nil, errors.NotFoundf("Unknown Api Type")
}
